{ --------------------------------------------------------------- }
{ Dieser Quelltext ist urheberrechtlich geschuetzt.               }
{ (c) 1991-1999 Peter Mandrella                                   }
{ (c) 2000-2001 OpenXP-Team                                       }
{ (c) 2002-2005 FreeXP, http://www.freexp.de                      }
{ CrossPoint ist eine eingetragene Marke von Peter Mandrella.     }
{                                                                 }
{ Die Nutzungsbedingungen fuer diesen Quelltext finden Sie in der }
{ Datei SLIZENZ.TXT oder auf www.crosspoint.de/oldlicense.html.   }
{ --------------------------------------------------------------- }
{ $Id: xpfiles.inc,v 1.2.2.5 2005/01/01 09:56:48 mw Exp $ }

{ Include fr UUZ.PAS und UUCICO.PAS }


{ fn:         Unix-Dateiname, evtl. incl. Pfad                   }
{ destdir<>'' -> Namenskollision in diesem Verzeichnis vermeiden }

function Unix2DOSfile(fn,destdir:pathstr):pathstr;
var p,i     : byte;
    allowed : set of char;
    name    : namestr;
    ext     : extstr;
    n       : word;
begin
  UpString(fn);
  p:=length(fn);
  while (fn[p]<>'/') and (p>0) do dec(p);
  if p>0 then delete(fn,1,p);
  if fn='~' then fn:='';
  if right(fn,6)='.TAR.Z' then            { .tar.z -> .taz }
    fn:=left(fn,length(fn)-5)+'TAZ';
  p:=pos(':',fn);
  if (p>0) and (p<length(fn)) then        { device: entfernen }
    delete(fn,1,p);
  p:=length(fn);
  while (p>0) and (fn[p]<>'.') do dec(p);
  if p>1 then begin
    fn:=left(fn,p+3);           { Extension auf 3 Zeichen krzen }
    dec(p);
    end;
  allowed:=['A'..'Z','_','-','','','','','','','#','@','$','!','0'..'9'];
  for i:=1 to p do
    if not (fn[i] in allowed) then   { linken Teil nach DOS konvertieren }
      fn[i]:='-';
  allowed:=allowed+['.'];
  for i:=max(1,p) to length(fn) do   { Extension nach DOS konvertieren }
    if not (fn[i] in allowed) then
      fn[i]:='-';
  p:=cpos('.',fn);
  if p=0 then begin             { Datei ohne Extension auf 8 Zeichen krzen }
    name:=left(fn,8); ext:='';
    end
  else begin                    { Datei mit Extension auf 8+3 zeichen krzen }
    name:=left(fn,min(8,p-1)); ext:=mid(fn,p);
    end;
  if length(ext)=2 then n:=10
  else n:=1;
  while (destdir<>'') and (n<999) and exist(destdir+name+ext) do begin
    ext:=left(ext,4-length(strs(n)))+strs(n);   { '.' mitrechnen! }
    inc(n);
    end;
  Unix2DOSfile:=name+ext;
end;

{
  $Log: xpfiles.inc,v $
  Revision 1.2.2.5  2005/01/01 09:56:48  mw
  MW: - Willkommen im Jahr 2005

  Revision 1.2.2.4  2004/01/09 13:57:37  mw
  MW: - Wir haben jetzt 2004!!

  Revision 1.2.2.3  2003/12/14 14:02:51  mw
  MW: - Nochmalige Korrektur der Quellcodeheader

  Revision 1.2.2.2  2003/12/14 10:47:42  mw
  MW: - Quelltextheader an FreeXP angepasst.

  Revision 1.2.2.1  2003/01/15 16:02:18  mw
  MW: - Fehlende CVS-Infos ergnzt (ID und Log wird jetzt
        bei allen Quelldateien in die Dateien geschrieben.
        Assembler-Quellen nur ID.

}
 
