@ECHO OFF
REM $Id: build.bat,v 1.1.2.21 2005/11/01 17:02:18 mw Exp $
REM FreeXP "make" Batchdatei: Kompiliert alle fuer XP relevanten
REM Programme und Resourcen

SET TARGET=.\BUILD\DOS16\XPDIR
SET COMP=C:\PROGRA~1\BP\BIN\BPC -CD -B -E%TARGET%
SET TOUCH=TOUCH.EXE

SET IHS=IHS
SET RC=RC
SET DOCFORM=DOCFORM

REM ERSTMAL VERZEICHNISSE ANLEGEN UND ZURCK INS SOURCEDIRECTORY
MD XPDIR
CD XPDIR
MD DOC
MD BEISPIEL
MD SAMPLES
CD ..
CD ..
CD ..

REM HILFSPROGRAMME COMPILIEREN
%COMP% IHS
IF ERRORLEVEL 1 GOTO FEHLER
%COMP% RC
IF ERRORLEVEL 1 GOTO FEHLER
%COMP% DOCFORM
IF ERRORLEVEL 1 GOTO FEHLER
%COMP% TOUCH

REM HILFSPROGRAMME VERSCHIEBEN
MOVE BUILD\DOS16\XPDIR\IHS.EXE DOC\IHS.EXE
MOVE BUILD\DOS16\XPDIR\DOCFORM.EXE DOC\DOCFORM.EXE
MOVE BUILD\DOS16\XPDIR\RC.EXE RC.EXE

REM ALLES COMPILIEREN
%COMP% MAGGI
IF ERRORLEVEL 1 GOTO FEHLER
%COMP% NDIFF
IF ERRORLEVEL 1 GOTO FEHLER
%COMP% PMCONV
IF ERRORLEVEL 1 GOTO FEHLER
%COMP% UUCICO
IF ERRORLEVEL 1 GOTO FEHLER
%COMP% UUCP-FL1
IF ERRORLEVEL 1 GOTO FEHLER
%COMP% UUZ
IF ERRORLEVEL 1 GOTO FEHLER
%COMP% XP
IF ERRORLEVEL 1 GOTO FEHLER
%COMP% XP-FM
IF ERRORLEVEL 1 GOTO FEHLER
%COMP% XPME
IF ERRORLEVEL 1 GOTO FEHLER
%COMP% YUP2PKT
IF ERRORLEVEL 1 GOTO FEHLER
%COMP% ZFIDO
IF ERRORLEVEL 1 GOTO FEHLER
%COMP% ZPR
IF ERRORLEVEL 1 GOTO FEHLER

REM Resourcen compilieren
%RC% XP-D
IF ERRORLEVEL 1 GOTO FEHLER
%RC% XP-E
IF ERRORLEVEL 1 GOTO FEHLER
%RC% XPFM-D
IF ERRORLEVEL 1 GOTO FEHLER
%RC% XPFM-E
IF ERRORLEVEL 1 GOTO FEHLER
%RC% XPUU-D
IF ERRORLEVEL 1 GOTO FEHLER
%RC% XPUU-E
IF ERRORLEVEL 1 GOTO FEHLER

REM Documentation docformen
CD DOC
%IHS% XP
IF ERRORLEVEL 1 GOTO FEHLER
%IHS% XP-E
IF ERRORLEVEL 1 GOTO FEHLER
%DOCFORM% xpoint.dq xpoint.txt 71 3 -p -x
IF ERRORLEVEL 1 GOTO FEHLER
%DOCFORM% fido.dq fido.txt 71 3 -p -tI\Grundlagen -kFido
IF ERRORLEVEL 1 GOTO FEHLER
%DOCFORM% uucp.dq uucp.txt 71 3 -p -tI\Grundlagen -kUUCP
IF ERRORLEVEL 1 GOTO FEHLER
%DOCFORM% xpme.dq xpme.txt 71 3 -p -t### -kXPME
IF ERRORLEVEL 1 GOTO FEHLER
%DOCFORM% zpr.dq zpr.txt 71 3 -p -t### -kZPR
IF ERRORLEVEL 1 GOTO FEHLER

REM HILFSPROGRAMME ENTFERNEN
DEL IHS.EXE
DEL DOCFORM.EXE

REM HILFEDATEIEN VERSCHIEBEN
MOVE *.hlp ..\BUILD\DOS16\XPDIR

REM BP-Unitdateien von FreeXP entfernen
CD ..
CD BUILD
CD DOS16
CD XPDIR
DEL *.tpu
CD ..
CD ..
CD ..

REM RESOURCECOMPILER ENTFERNEN
DEL RC.EXE

REM RESOURCEN VERSCHIEBEN
MOVE *.RES BUILD\DOS16\XPDIR

REM DOCUMENTATION KOPIEREN
COPY DOC\COPYING BUILD\DOS16\XPDIR\DOC
COPY DOC\README.TXT BUILD\DOS16\XPDIR\DOC
COPY DOC\SLIZENZ.TXT BUILD\DOS16\XPDIR\DOC
COPY DOC\SLICENCE.TXT BUILD\DOS16\XPDIR\DOC
COPY DOC\UPDATE.TXT BUILD\DOS16\XPDIR\DOC
COPY DOC\ZM.TXT BUILD\DOS16\XPDIR\DOC

REM DOCFORM-Documente verschieben
MOVE DOC\FIDO.TXT BUILD\DOS16\XPDIR\DOC
MOVE DOC\UUCP.TXT BUILD\DOS16\XPDIR\DOC
MOVE DOC\XPOINT.TXT BUILD\DOS16\XPDIR\DOC
MOVE DOC\XPME.TXT BUILD\DOS16\XPDIR\DOC
MOVE DOC\ZPR.TXT BUILD\DOS16\XPDIR\DOC

REM BEISPIELE KOPIEREN
COPY BEISPIEL\*.* BUILD\DOS16\XPDIR\BEISPIEL
COPY SAMPLES\*.* BUILD\DOS16\XPDIR\SAMPLES
COPY BEISPIEL\*.scr BUILD\DOS16\XPDIR\SAMPLES

REM SONSTIGES
COPY File_id.diz BUILD\DOS16\XPDIR
COPY Binaries\*.* BUILD\DOS16\XPDIR
COPY FIDO.PC BUILD\DOS16\XPDIR

REM Ab ins XPDIR
CD BUILD
CD DOS16
CD XPDIR

REM Bei Bedarf UPX aktivieren!!
REM UPX -9 *.EXE

REM ALLES EINMAL TOUCHEN
REM mit MW-Touch
%TOUCH% .\#\*.* /G
CD ..
MD DISTRI
CD XPDIR

REM Zuletzt alle Archive erstellen ...
MOVE %TOUCH% ..\DISTRI
REM Distributionsarchiv
PKZIP -rP ..\DISTRI\FXP321.ZIP *.*
REM 2 Disketten Distribution
PKZIP -rP ..\DISTRI\FXP321-1.ZIP @..\MDISK.LST
PKZIP -rP -x@..\MDISK.LST ..\DISTRI\FXP321-2.ZIP *.*
REM Updatearchiv
REM PKZIP -rP ..\DISTRI\FXP321UP.ZIP @..\..\UPDATE.LST
CD ..
CD ..
CD ..
REM Sourcekomplettarchiv
PKZIP -rP -x@BUILD\EXCLUDE.LST BUILD\DOS16\DISTRI\FXP321S.ZIP *.*
REM 2 Disketten Source
PKZIP -rP -x@BUILD\EXCLUDE.LST -x@BUILD\SDISK.LST BUILD\DOS16\DISTRI\FXP321S1.ZIP *.*
PKZIP -rP -x@BUILD\EXCLUDE.LST BUILD\DOS16\DISTRI\FXP321S2.ZIP @BUILD\SDISK.LST
CD BUILD
CD DOS16
CD DISTRI

REM Ein letzter Touch
%TOUCH% *.* /R=../XPDIR/XP.EXE /G
DEL %TOUCH%
CD ..
GOTO ENDE

REM Und fertig.
:FEHLER
ECHO OFF
GOTO ENDE
{
   FreeXP v3.21 Build-Script.
}
:ENDE
