{ --------------------------------------------------------------- }
{ Dieser Quelltext ist urheberrechtlich geschuetzt.               }
{ (c) 1991-1999 Peter Mandrella                                   }
{ (c) 2000-2001 OpenXP-Team                                       }
{ (c) 2002-2005 FreeXP, http://www.freexp.de                      }
{ CrossPoint ist eine eingetragene Marke von Peter Mandrella.     }
{                                                                 }
{ Die Nutzungsbedingungen fuer diesen Quelltext finden Sie in der }
{ Datei SLIZENZ.TXT oder auf www.crosspoint.de/oldlicense.html.   }
{ --------------------------------------------------------------- }
{ $Id: xp.pas,v 1.9.2.8 2005/01/01 09:56:50 mw Exp $ }

{   Cross\\//        }
{        //\\point   }

{$I XPDEFINE.INC }

{$F+}
{$M 32768,150000,655360}
program xp;

uses xpx,crt,dos,typeform,uart,keys,fileio,inout,help,video,datadef,
     database,databaso,maske,mouse,maus2,winxp,win2,montage,lister,archive,
     printerx,crc16,resource,stack,clip,eddef,editor,feiertag,
     xpdiff,xpdatum,xpcrc32, xpglobal,
{$IFDEF CAPI }
     capi,
{$ENDIF }
     xp0,      { Definitionen       }
     xp1,      { allg. Routinen     }
     xp1o,
     xp1o2,
     xp1help,  { Online-Hilfe u.a.  }
     xp1input, { Eingabefunktionen  }
     xpnt,     { Netztypen          }
     xp_des,   { DES-Codierung      }
     xp_pgp,   { PGP-Codierung      }
     xpkeys,   { F-Tasten/Makros    }
     xp_uue,   { UUencode/UUdecode  }
     xp2,      { Startup            }
     xp2db,    { Database-Startup   }
     xp2c,     { Konfiguration      }
     xp2f,     { Farben & F-Keys    }
     xp3,      { Datenbearbeitung   }
     xp3o,
     xp3o2,
     xp3ex,    { Msg. extrahieren   }
     xp4,      { Hauptmodul         }
     xp4e,
     xp4o,
     xp4o2,    { Bezge, packen     }
     xp4o3,
     xpauto,   { Autoversand/-Exec  }
     xp5,      { Utilities          }
     xpreg,    { Registrierung      }
     xp6,      { Nachrichten senden }
     xp6o,     { Unversandt, Weiterleiten }
     xp7,      { Netcall            }
     xp7o,
     xp7f,     { Fido-Netcall       }
     xpuu,     { ucico              }
     xp8,      { 'maps & Filesercer }
     xp9,      { UniSel (B/G/S/K)   }
     xp10,     { Timing-Lst./Makros }
     xpe,      { Editor             }
     xpstat,   { Statistik          }
     xpterm,   { CrossTerm          }
     xpcc,     { Verteiler          }
     xpfido,   { Nodelist u.a.      }
     xpfidonl, { Nodelist-Config    }
     xpf2,
     xpmaus,   { Maus-Funktionen    }
     xp_iti,   { Maus-ITI-Infofile  }
     xpview,   { Binfile-Viewer     }
     xpmime,   { Multipart-Decode   }
{$IFDEF BP }
     xpfonts,  { interne Fonts      }
{$ENDIF }
     xpimpexp; { Import/Export      }

{$IFNDEF Ver32 } { Bei 32 Bit brauchen wir keine Overlays }
{$O win2}    {$O help}    {$O maske}    {$O lister}   {$O archive}
{$O clip}    {$O editor}  {$O databaso} {$O feiertag}
{$O xp_uue}  {$O xp1o}    {$O xp1o2}    {$O xp_pgp}   {$O xp1input}
{$O xp1help}
{$O xp2}     {$O xp2c}    {$O xp2f}     {$O xp2db}
{$O xp3o}    {$O xp3o2}   {$O xp3ex}
{$O xp4}     {$O xp4e}    {$O xp4o}     {$O xp4o2}    {$O xp4o3}
{$O xpauto}  {$O xp5}     {$O xpreg}    {$O xp6}      {$o xp6o}
{$O xp7}     {$O xp7o}    {$O xp7f}
{$O xpuu}    {$O xp8}     {$O xp9}      {$O xp9bp}    {$O xp10}    {$O xpe}
{$O xpstat}  {$O xpterm}  {$O xpcc}     {$O xpmaus}   {$O xp_iti}
{$O xpfido}  {$O xpf2}    {$O xpfidonl}
{$O xpview}  {$O xpmime}  {$O xpimpexp} {$O xpfonts}
{$O xpnt}    {$O xpdatum} {$O XP3}
{$IFDEF CAPI }
{$O capi }
{$ENDIF }
{$ENDIF }

label ende;

begin
  readpar;
  loadresource;
  initvar;
  testlock;
  TestAutostart;
  if not quit then
  begin
    cursor(curoff);
    defaultcolors; SetColors;
    read_regkey;
    readconfig;    { setzt Mens }
    if ParG1 or ParG2 then
    begin
      gtest;
      goto ende;
    end;
    ChangeTboxSN;  { alte IST-Box-Seriennummer -> Config-File }
    test_pfade;
    readkeydefs;
    if not parmono then
    begin
      readcolors;
      SetColors;
    end;
    showscreen(true);
    DelTmpfiles('*.$$$');
    if not DelViewTmp then Delviewtmp:=(getenv('DELVTMP')<>'');
    if Delviewtmp then begin  {Temporaere Viewer-Files loeschen}     
      DelTmpfiles('TMP-????.*');
      chdir(temppath);
      DelTmpfiles('TMP-????.*');
      chdir(ownpath);
      end;
    testdiskspace;
    {$IFDEF BP }
    testfilehandles;
    {$ENDIF }
    initdatabase;
    if password then
    begin
      test_defaultbox;
      ReadDomainlist;
      if quit then
      begin    { Registrierungshinweis abgebrochen }
        closedatabases;
        exitscreen(0);
        goto Ende;
      end;
{$IFDEF Beta } { MK 25.01.2000 Betameldung anzeigen, /nb schaltet diese ab }
      if not ParNoBeta then
      begin
        BetaMessage;
        if quit then
        begin    { Betahinweis abgebrochen }
           closedatabases;
           exitscreen(0);
           goto Ende;
        end;
      end;
{$ENDIF }
      test_defaultgruppen;
      test_systeme;
      DefaultViewer := nil;
      DefTextViewer := nil;
      PTextViewer := nil;
      ReadDefaultViewers;
      testtelefon(telefonnr^);
      check_date;
      InitNodelist;
      startup:=false;
      showusername;
      AutoSend;
      AutoExec(true);
      if not AutoMode then     { in XP7 }
        mainwindow;
      AutoStop;
      FlushSmartdrive(true);
      closedatabases;
      exitscreen(iif(ParNojoke,0,1));
      delete_tempfiles;
      set_checkdate;
    end
  else
    exitscreen(2);
  end;
ende:
  closeresource;
  runerror:=false;
  halt(errlevel);
end.
{
  $Log: xp.pas,v $
  Revision 1.9.2.8  2005/01/01 09:56:50  mw
  MW: - Willkommen im Jahr 2005

  Revision 1.9.2.7  2004/10/21 15:26:29  mw
  MW: - Beseitigung von noch gefundenen 32Bit-Teilen.

  Revision 1.9.2.6  2004/01/09 13:57:33  mw
  MW: - Wir haben jetzt 2004!!

  Revision 1.9.2.5  2003/12/14 14:02:52  mw
  MW: - Nochmalige Korrektur der Quellcodeheader

  Revision 1.9.2.4  2003/12/14 10:47:42  mw
  MW: - Quelltextheader an FreeXP angepasst.

  Revision 1.9.2.3  2000/11/17 12:16:18  mk
  - Probleme beim aktualisieren der Defautviewer behoben

  Revision 1.9.2.2  2000/05/02 04:19:00  jg
  - XPoint.cfg Schalter DelViewTmp
    macht dasselbe wie die Umgebungsvariable DELVTMP

  Revision 1.9.2.1  2000/04/23 14:48:45  jg
  Aenderungen fuer externe Viewer:

  - xpview.pas, xp1o.pas: Routinen aus Version 3.21.023 uebernommen:
    Fido-File-Attaches werden beachtet; "Start" als Viewer ist erlaubt;
    File-Extensions bei erstellten Tempfiles werden korrekt gesetzt;
    Filenamen mit langen Pfaden werden nicht mehr abgeschnitten;
    Dateien mit Leerzeichen im Filenamen koennen angezeigt werden;
    Unterstuetzung von Multiformat-Typen (z.B Application/octet-stream)
    (Dateiendung aus Mail wird verwendet wemm keine beim Mimetyp steht);
    Alternative Tempfile-Behandlung mit gesetzter Umgebungsvariable DELVTMP
    (keine Loesch-Warte-Batch, sondern Loeschen erst beim naechsten XP-Start).

  - xp0.pas, xp1.pas: Aenderungen fuer die DELVTMP Funktion aus 3.21.023

  - xp4o.pas, xp4w.inc: Uebergabe des Fido-Fileattach-Flags an xpview.viewfile

  - xp9.pas: Mimetyp */* nicht mehr erstellbar

  Revision 1.9  2000/03/02 18:32:24  mk
  - Code ein wenig aufgeraeumt

}
