{ --------------------------------------------------------------- }
{ Dieser Quelltext ist urheberrechtlich geschuetzt.               }
{ (c) 2000-2001 OpenXP-Team                                       }
{ (c) 2002-2005 FreeXP, http://www.freexp.de                      }
{ CrossPoint ist eine eingetragene Marke von Peter Mandrella.     }
{                                                                 }
{ Die Nutzungsbedingungen fuer diesen Quelltext finden Sie in der }
{ Datei SLIZENZ.TXT oder auf www.crosspoint.de/oldlicense.html.   }
{ --------------------------------------------------------------- }
{ Globale Konstanten/Variablen (FreeXP) und Tools                 }
{ --------------------------------------------------------------- }
{ $Id: xpglobal.pas,v 1.7.2.19 2005/01/01 09:56:52 mw Exp $ }

unit xpglobal;

interface

{$I XPDEFINE.INC }

const
  verstr      = 'v3.21';  { Versionsnr. - steht nur an dieser Stelle }
  betastr     = '';        { '' oder ' beta' }

{$IFDEF DPMI}
  pformstr    = ' DOS/XL';    { 16 Bit DPMI mit Borland Pascal }
{$ELSE}
  pformstr    = ' DOS/16';    { 16 Bit Realmode mit Borland Pascal }
{$ENDIF}

{ Die folgenden drei Konstanten mssen Sie ergnzen, bevor Sie      }
{ CrossPoint compilieren knnen. Falls Die das compilierte Programm }
{ weitergeben mchten, mssen der angegebene Name korrekt und die   }
{ E-Mail-Adresse erreichbar sein (siehe LIZENZ.TXT).                }
{
{ Beispiel:                                                         }
{                                                                   }
{ const  author_name = 'Ralf Mller';                               }
{        author_mail = 'ralf@t-offline.de';                         }
{        x_copyright = '(c) 2001';                                  }
{                                                                   }
{ Diese Informationen werden bei Programmstart und bei              }
{ /XPoint/Registrierung angezeigt.                                  }

  author_name = 'FreeXP';
  author_fido = '2:2433/460';
  author_mail = 'support@freexp.de';
  author_url  = 'http://www.freexp.de/';
  xp_xp       : string[17] = 'CrossPoint/FreeXP';
  xp_display  : string[6]  = 'FreeXP';
  xp_client   : string[10] = 'CrossPoint';
  xp_origin   : string[21] = '--- CrossPoint/FreeXP';
  xp_old      : string[32] = 'OpenXP/16 (compatibility string)';  { fr UKAW, XPNews u.. }
  x_copyright = '(c) 2002-2005';

type
  { Regeln fr Datentypen unter 16/32 Bit

  Die gre einiger Datentypen unterscheidet sich je nach verwendetem
  Compiler und der Systemumgebung. Folgende Regeln sollten beachtet werden:

  Der im Regelfall zu verwendede Datentyp ist Integer. Dieser Datentyp
  ist unter 16 Bit natrlich 16 Bit gro und unter 32 Bit wiederum 32 Bit
  gro und immer signed (vorzeichenbehaftet). Dieser Datentyp ist immer der
  _schnellste_ fr das System verfgbare Datentyp, sollte also in Schleifen
  usw. wenn mglich genommen und den spezielleren Datentypen vorgezogen
  werden.

  Folgende Datentypen sind immer gleich gro und z.B. fr Records geeignet:
  Byte       1 Byte  unsigned  0..255
  SmallWord  2 Byte  unsigned  0..65535
  DWord      4 Byte  unsigned  0..4294967295
  (Vorsicht bei BP und VP, dort gibt es kein echtes DWord)

  Integer8   1 Byte  signed   -128..127
  Integer16  2 Byte  signed   -32768..32767
  Integer32  4 Byte  signed   -2147493647..2147493647

  }

{ Borland Pascal bis Version 8, 16 Bit }
    integer8 =   shortint;
    integer16 =  integer;
    integer32 =  longint;
    smallint =   integer;
    smallword =  word;
    dword =      longint; { Vorsicht: siehe oben! }

implementation

end.
{
  $Log: xpglobal.pas,v $
  Revision 1.7.2.19  2005/01/01 09:56:52  mw
  MW: - Willkommen im Jahr 2005

  Revision 1.7.2.18  2004/01/09 13:57:34  mw
  MW: - Wir haben jetzt 2004!!

  Revision 1.7.2.17  2003/12/17 07:14:22  mw
  JM: - Crosspoint/FreeXP 3.21 ist nun Freeware

  Revision 1.7.2.16  2003/12/14 14:02:53  mw
  MW: - Nochmalige Korrektur der Quellcodeheader

  Revision 1.7.2.15  2003/12/14 12:07:51  mw
  MW: - 32Bit-Reste entfernt.

  Revision 1.7.2.14  2003/12/14 10:47:43  mw
  MW: - Quelltextheader an FreeXP angepasst.

  Revision 1.7.2.13  2003/01/15 16:02:18  mw
  MW: - Fehlende CVS-Infos ergnzt (ID und Log wird jetzt
        bei allen Quelldateien in die Dateien geschrieben.
        Assembler-Quellen nur ID.

  Revision 1.7.2.12  2001/06/10 10:52:32  mk
  - Copyright auf 2000-01 geaendert

  Revision 1.7.2.11  2001/05/17 15:01:40  mk
  - Versionsnummer auf 3.20e geaendert

  Revision 1.7.2.10  2000/12/25 18:20:47  mk
  - Versionsnummer auf 3.20d geandert

  Revision 1.7.2.9  2000/12/20 03:03:30  mk
  - Versionsnummer auf 3.20c geaendert

  Revision 1.7.2.8  2000/12/17 19:18:02  mk
  - Versionnummer auf 3.20b geaendert

  Revision 1.7.2.7  2000/12/06 09:43:16  mk
  - OpenXP-Team mit Bindestrich in der Mitte

  Revision 1.7.2.6  2000/08/06 10:00:00  mk
  - Versionsaenderung auf 3.20a

  Revision 1.7.2.5  2000/07/23 09:43:30  mk
  - Versionsaenderung auf 3.20

  Revision 1.7.2.4  2000/07/07 17:01:14  mk
  - Versionsaenderung auf 3.20 RC5

  Revision 1.7.2.3  2000/06/01 15:45:21  mk
  - RC4 definiert

  Revision 1.7.2.2  2000/04/30 09:47:47  mk
  - Versionsaenderung auf 3.20 RC3

  Revision 1.7.2.1  2000/04/12 09:27:12  mk
  - Versionsaenderung auf 3.20 RC2

  Revision 1.7  2000/03/02 18:32:24  mk
  - Code ein wenig aufgeraeumt

}
