{ --------------------------------------------------------------- }
{ Dieser Quelltext ist urheberrechtlich geschuetzt.               }
{ (c) 1991-1999 Peter Mandrella                                   }
{ (c) 2000-2001 OpenXP-Team                                       }
{ (c) 2002-2005 FreeXP, http://www.freexp.de                      }
{ CrossPoint ist eine eingetragene Marke von Peter Mandrella.     }
{                                                                 }
{ Die Nutzungsbedingungen fuer diesen Quelltext finden Sie in der }
{ Datei SLIZENZ.TXT oder auf www.crosspoint.de/oldlicense.html.   }
{ --------------------------------------------------------------- }
{ $Id: xpreg.pas,v 1.6.2.10 2005/01/01 09:56:52 mw Exp $ }

{ Registrierung }

{$I XPDEFINE.INC }
{$IFDEF BP }
  {$O+,F+}
{$ENDIF }

unit xpreg;

interface

uses  crt,dos,typeform,fileio,inout,keys,winxp,maus2,maske,resource,
      xp0,xp1,xp1o,xp1o2,xp1input,xpglobal;

procedure license;
procedure BetaMessage;
function  LizenzNummer:string;


implementation  { --------------------------------------------------- }

procedure license;
var x,y,i : byte;
    s     : string;
    p     : byte;

    msglines : byte;

    sely  : byte;
    sels  : string[80];
    n     : shortint;
    z     : taste;

  procedure ReadReg;
  var x,y  : byte;
      brk  : boolean;
      code : string[20];
      t    : text;
      nr   : longint;
      z    : taste;
  begin
    if not is_freereg then
    begin
      pushhp(1552);
      if ReadJN(getres2(521,1),false) then  { 'Sie sind bereits registriert. Mchten Sie die Registrierung lschen' }
      with registriert do begin
        _era('regdat.xp');
        nr:=0;
        tc:='F';
        komreg:=false;
        orgreg:=false;
        message(getres2(521,8));    { 'Registrierung wurde gelscht.' }
        mdelay(1500);
        closebox;
      end;
      pophp;
      exit;
    end;
    code:='';
    dialog(length(getres2(521,2))+27,3,'',x,y);
    maddstring(3,2,getres2(521,2),code,20,20,'');   { 'Registrierungs-Code: ' }
      mhnr(1553);
    readmask(brk);
    enddialog;
    if (code<>'') and (firstchar(code)<'A') then code:='A'+code;
    if brk or (code='') then
    begin
      message(getres2(521,3));    { 'Na, dann eben nicht.' }
      wkey(2,false);
      closebox;
    end
    else if (cpos('-',code)=0) or
            (ival(copy(code,2,cpos('-',code)-2))=0) then
    begin
      message(getres2(521,4));   { 'Ungltiger Registrierungs-Code.' }
      wkey(2,false);
      closebox;
    end
    else begin
      if ival(firstchar(code))>0 then
        nr:=ival(left(code,cpos('-',code)-1))
      else
        nr:=ival(copy(code,2,cpos('-',code)-2));
      if IsKomCode(nr) or IsOrgCode(nr) then
      begin
        msgbox(53,8,'',x,y);
        mwrt(x+3,y+2,'Sie sind als nicht-privater '+xp_display+'-Anwender');
        mwrt(x+3,y+3,'registriert. Soll dies in Ihren Nachrichten er-');
        mwrt(x+3,y+4,'kennbar sein?');
        z:='';
        pushhp(1554);
        if readbutton(x+3,y+6,2,getres(107),1,true,z)=1 then  { Ja/Nein }
          code:='!'+code;
        pophp;
        closebox;
      end;
      assign(t,regdat);
      rewrite(t);
      writeln(t,code);
      close(t);
      msgbox(47,8,'',x,y);
      moff;
      wrt(x+3,y+2,getres2(521,5));   { 'Der Registrierungscode wurde gespeichert.' }
      wrt(x+3,y+3,getres2(521,6));   { 'CrossPoint beendet sich jetzt selbst und' }
      wrt(x+3,y+4,getres2(521,7));   { 'mu danach neu gestartet werden.' }
      wrt(x+3,y+6,getres(12));       { 'Taste drcken ...' }
      mon;
      xp1.wait(curon);
      quit:=true;
    end;
  end;

label again;

begin
  msglines:=ival(getres2(520,0));
  msgbox(70,msglines+9,'',x,y);
  moff;
  attrtxt(col.colmboxhigh);
  wrt(x+9,y+2,'\\//');
  wrt(x+9,y+3,'//\\');
  attrtxt(col.colmbox);
  wrt(x+3,y+2,'Cross');
  wrt(x+14,y+3,'Point');
  s := '(c) 1992-1999 ' + pm;
  wrt(x+67-length(s),y+1,s);
  s := '(c) 2000-2001' + forms(' ',5) + iifs(deutsch,'OpenXP-Team','OpenXP Team');
  wrt(x+67-length(s),y+2,s);
  s := forms(x_copyright,14) + forms(' ',length(pm)-length(author_name)) + author_name;
  wrt(x+67-length(s),y+3,s);
  s:=getres2(520,19)+LizenzNummer;   { 'Lizenznummer: ' }
  wrt(x+67-length(s),y+4,s);
  for i:=1 to msglines do
  begin
    s:=getres2(520,i);
    gotoxy(x+3,y+5+i);
    repeat
      p:=cposx('*',s);
      write(left(s,p-1));
      delete(s,1,p);
      p:=cposx('*',s);
      attrtxt(col.colmboxhigh);
      write(left(s,p-1));
      attrtxt(col.colmbox);
      delete(s,1,p);
    until s='';
  end;
  sels:=getres2(520,30);  { ' S^LIZENZ.TXT anzeigen , Registrierungs^code eingeben ' }
  mon;
again:
  sely:=y+msglines+7;
  attrtxt(col.colmbox);
  mwrt(x+3,sely,sp(65));
  z:='';
  n:=1;
  pushhp(1551);
  n:=ReadButton(x+3,sely,2,'*'+sels,n,true,z);
  pophp;
  s:='DOC\' + getres2(520,40);   { 'SLIZENZ.TXT' }
  case n of
    1 : begin
          if not exist(s) then           { 'SLIZENZ.TXT' }
            fehler(getreps2(520,41,s))   { '%s fehlt!' }
          else
            if listfile(s,getres2(520,42),true,false,0)=0 then;    { 'D=Drucken    <Esc>=Ende' }
          goto again;
          end;
    2 : begin
          ReadReg;
          if not quit then goto again;
        end;
  end;
  closebox;
  freeres;
end;

procedure BetaMessage;
var x,y,i,p  : byte;
    msglines : byte;
    z        : taste;
    s        : string;
begin
  msglines:=ival(getres2(530,0));
  msgbox(72,msglines+8,'',x,y);
  moff;
  attrtxt(col.colmboxhigh);
  wrt(x+9,y+2,'\\//');
  wrt(x+9,y+3,'//\\');
  attrtxt(col.colmbox);
  wrt(x+3,y+2,'Cross');
  wrt(x+14,y+3,'Point');
  s := '(c) 1992-1999 ' + pm;
  wrt(x+69-length(s),y+1,s);
  s := '(c) 2000-2001' + forms(' ',5) + iifs(deutsch,'OpenXP-Team','OpenXP Team');
  wrt(x+69-length(s),y+2,s);
  s := forms(x_copyright,14) + forms(' ',length(pm)-length(author_name)) + author_name;
  wrt(x+69-length(s),y+3,s);
  for i:=1 to msglines do begin
    s:=getres2(530,i);
    gotoxy(x+3,y+4+i);
    repeat
      p:=cposx('*',s);
      write(left(s,p-1));
      delete(s,1,p);
      p:=cposx('*',s);
      attrtxt(col.colmboxhigh);
      write(left(s,p-1));
      attrtxt(col.colmbox);
      delete(s,1,p);
    until s='';
  end;
  mon;
  pushhp(1550);
  quit := (ReadButton(x+45,y+msglines+6,2,'*'+getres2(530,30),1,true,z) <> 1);
  pophp;
  closebox;
  freeres;
end;

function LizenzNummer:string;
begin
  with registriert do
    if is_freereg then LizenzNummer:=getres2(361,60) else
    if orgreg then LizenzNummer:='Org-'+tc+strs(nr) else
    if komreg then LizenzNummer:='Kom-'+tc+strs(nr) else
    LizenzNummer:=tc+strs(nr);
end;

end.
{
  $Log: xpreg.pas,v $
  Revision 1.6.2.10  2005/01/01 09:56:52  mw
  MW: - Willkommen im Jahr 2005

  Revision 1.6.2.9  2004/01/09 13:57:35  mw
  MW: - Wir haben jetzt 2004!!

  Revision 1.6.2.8  2003/12/21 11:30:48  mw
  MW: - berflssige Procedure About entfernt.

  Revision 1.6.2.7  2003/12/17 07:14:22  mw
  JM: - Crosspoint/FreeXP 3.21 ist nun Freeware

  Revision 1.6.2.6  2003/12/14 14:02:53  mw
  MW: - Nochmalige Korrektur der Quellcodeheader

  Revision 1.6.2.5  2003/12/14 10:47:43  mw
  MW: - Quelltextheader an FreeXP angepasst.

  Revision 1.6.2.4  2000/12/15 00:24:08  mk
  - typo beseitigt

  Revision 1.6.2.3  2000/12/14 17:53:38  mk
  - Programmnamen in Regformular schreiben

  Revision 1.6.2.2  2000/12/06 09:44:08  mk
  - OpenXp vor dem (c)

  Revision 1.6.2.1  2000/06/01 15:17:04  mk
  - Unnoetigen Parameter in Multi2 entfernt

  Revision 1.6  2000/02/19 11:40:09  mk
  Code aufgeraeumt und z.T. portiert

  Revision 1.5  2000/02/15 20:43:37  mk
  MK: Aktualisierung auf Stand 15.02.2000

}
